package de.ozgcloud.operator.keycloak.user;

import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

import de.ozgcloud.operator.keycloak.user.OzgKeycloakUserSpec.KeycloakUserSpecUser;

@Component
class UserNameConverter {

	private static final String USER_NAME_VALIDITY_REGEX = "[^a-zA-Z0-9]";

	public String toSecretName(KeycloakUserSpecUser userSpec) {
		return clarifyName(userSpec.getUsername().toLowerCase()) + "-credentials";
	}

	String clarifyName(String userName) {
		return userName.replaceAll(USER_NAME_VALIDITY_REGEX, StringUtils.EMPTY);
	}
}
