package de.ozgcloud.operator.keycloak.user;

import org.springframework.stereotype.Component;

import de.ozgcloud.operator.keycloak.user.OzgKeycloakUserSpec.KeycloakUserSpecUser;
import io.fabric8.kubernetes.api.model.ObjectMeta;
import io.fabric8.kubernetes.api.model.Secret;
import io.fabric8.kubernetes.api.model.SecretBuilder;

@Component
class UserSecretBuilder {

	static final String SECRET_TYPE = "Opaque";
	static final String SECRET_PASSWORD_FIELD = "password";
	static final String SECRET_NAME_FIELD = "name";

	public Secret build(String name, KeycloakUserSpecUser userSpec, String namespace) {
		return new SecretBuilder()
				.withType(SECRET_TYPE)
				.withMetadata(createMetaData(name, namespace))
				.addToStringData(SECRET_NAME_FIELD, userSpec.getUsername())
				.addToStringData(SECRET_PASSWORD_FIELD, userSpec.getPassword())
				.build();
	}

	private ObjectMeta createMetaData(String name, String namespace) {
		var metadata = new ObjectMeta();
		metadata.setName(name);
		metadata.setNamespace(namespace);

		return metadata;
	}
}