/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.operator.keycloak.user;

import java.util.List;
import java.util.UUID;

import de.ozgcloud.operator.keycloak.user.OzgKeycloakUserSpec.KeycloakUserSpecClientRole;
import de.ozgcloud.operator.keycloak.user.OzgKeycloakUserSpec.KeycloakUserSpecUser;
import de.ozgcloud.operator.keycloak.user.OzgKeycloakUserSpec.KeycloakUserSpecUserGroup;

class KeycloakUserSpecUserTestFactory {

	public static final String USERNAME = "dorothea";
	public static final String FIRSTNAME = "Dorothea";
	public static final String LASTNAME = "Doe";
	public static final String EMAIL = "dorothea@hasenamt.local";
	public static final String PASSWORD = UUID.randomUUID().toString();

	public static final String GROUP_NAME_1 = "GroupName1";
	public static final KeycloakUserSpecUserGroup GROUP1 = KeycloakUserSpecUserGroup.builder().name(GROUP_NAME_1).build();
	public static final String GROUP_NAME_2 = "GroupName2";
	public static final KeycloakUserSpecUserGroup GROUP2 = KeycloakUserSpecUserGroup.builder().name(GROUP_NAME_2).build();

	public static final String CLIENT_NAME = "alfa";
	public static final KeycloakUserSpecClientRole ROLE1 = KeycloakUserSpecClientRole.builder().clientId(CLIENT_NAME).roleName("ROLE1").build();
	public static final KeycloakUserSpecClientRole ROLE2 = KeycloakUserSpecClientRole.builder().clientId(CLIENT_NAME).roleName("ROLE2").build();

	public static KeycloakUserSpecUser create() {
		return createBuiler().build();
	}

	public static KeycloakUserSpecUser.KeycloakUserSpecUserBuilder createBuiler() {
		return KeycloakUserSpecUser.builder()
				.username(USERNAME)
				.firstName(FIRSTNAME)
				.lastName(LASTNAME)
				.email(EMAIL)
				.password(PASSWORD)
				.groups(List.of(GROUP1, GROUP2))
				.clientRoles(List.of(ROLE1, ROLE2));
	}
}
